﻿Imports System.ComponentModel

Namespace ViewModel
    Public Class MainVM
        Inherits ViewModelBase

        Public Sub New()
            Dim carList As New List(Of Model.Car)
            carList.Add(New Model.Car("Volkswagen Up!", 60))
            carList.Add(New Model.Car("Audi A3", 130))
            carList.Add(New Model.Car("Lamborghini Aventador", 700))
            carList.Add(New Model.Car("Volkswagen Multivan", 240))
            carList.Add(New Model.Car("Seat Ibiza", 90))
            carList.Add(New Model.Car("Skoda Karoq", 150))
            carList.Add(New Model.Car("Audi RS6", 650))
            carList.Add(New Model.Car("Seat Arona", 115))

            List1View = CollectionViewSource.GetDefaultView(carList.Where(Function(c) c.PS > 130))
            List2View = CollectionViewSource.GetDefaultView(carList.Where(Function(c) c.PS < 130))
            List3View = CollectionViewSource.GetDefaultView(carList.Where(Function(c) c.PS > 500))
        End Sub



        Private _list1View As ICollectionView
        Public Property List1View() As ICollectionView
            Get
                Return _list1View
            End Get
            Set(ByVal value As ICollectionView)
                _list1View = value
                RaisePropertyChanged()
            End Set
        End Property


        Private _list2View As ICollectionView
        Public Property List2View() As ICollectionView
            Get
                Return _list2View
            End Get
            Set(ByVal value As ICollectionView)
                _list2View = value
                RaisePropertyChanged()
            End Set
        End Property


        Private _list3View As ICollectionView
        Public Property List3View() As ICollectionView
            Get
                Return _list3View
            End Get
            Set(ByVal value As ICollectionView)
                _list3View = value
                RaisePropertyChanged()
            End Set
        End Property


        Private _lastSelectedCar As Model.Car
        Public Property LastSelectedCar() As Model.Car
            Get
                Return _lastSelectedCar
            End Get
            Set(ByVal value As Model.Car)
                _lastSelectedCar = value
                RaisePropertyChanged()
            End Set
        End Property


        Private _listBoxFocusChangedCommand As ICommand
        Public Property ListBoxFocusChangedCommand() As ICommand
            Get
                If _listBoxFocusChangedCommand Is Nothing Then _listBoxFocusChangedCommand = _ 
                    New RelayCommand(addressof ListBoxFocusChangedCommand_Execute,AddressOf ListBoxFocusChangedCommand_CanExecute)
                Return _listBoxFocusChangedCommand
            End Get
            Set(ByVal value As ICommand)
                _listBoxFocusChangedCommand = value
                RaisePropertyChanged()
            End Set
        End Property

        Private Function ListBoxFocusChangedCommand_CanExecute(obj As Object) As Boolean
            Return obj IsNot Nothing
        End Function

        Private Sub ListBoxFocusChangedCommand_Execute(obj As Object)
            LastSelectedCar = CType(obj, Model.Car)
        End Sub
    End Class
End Namespace